diff -uNrd -x CVS ircd-comstud-1.12-REL/ChangeLog ircd-devel/ChangeLog
--- ircd-comstud-1.12-REL/ChangeLog	Thu Dec  7 04:27:35 2000
+++ ircd-devel/ChangeLog	Tue Dec  5 12:59:09 2000
@@ -1,23 +1,26 @@
+2000/12/05  --- humble's FreeBSD happiness package 1.0 is rolled
 
-2000/12/07  --- 1.12-REL done
-
-2000/12/07:
-   -- numeric fix
-
-2000/11/23:
-   -- disallow '%' in hostnames
-
-2000/11/18:
-   -- subarg_comma was same as subarg_space.  Major oops.  How did that
-     happen?  Broke things like PRIVMSG nick1,nick2 etc..
+      This will work ONLY under FreeBSD... but you'll like it :P
 
-2000/11/07:
-   -- added 'checkhostname' flag to allow {}.  if an allow w/ an 'ipaddr'
-     has this flag, hostname matching will occur even when a connecting
-     client matches that ip in the allow{}.  ie, a hostname match can
-     override.
+   -- Add class directive "inherit" which copied settings from anothe class
+   -- Finish support for allow passwords
+   -- Gutted some evilness in the send and network polling routines
+   -- Totally rewrote poller to use kqueue() for SIGNIFICANT improvements
+   -- Added proper stats I displays for TCM happiness
+   -- Hid the "hidden" classes from stats y
+   -- Put more check on ircd.so, don't reload (and crash) if its not there
+   -- Redesigned the makefile and autoconf structure, much more soon...
+   -- Added FreeBSD accf (accept filter) support for efficiency
+   -- Added "sendbuf" and "recvbuf" socket buffer controls under class
+   -- Cleaned up some various bits of code here and there
+   -- Probably more that I can't recall right now...
 
+      MUCH MUCH *MUCH* more to come, some major rewrites of key components
+      on the way to a total ircd rewrite for the betterment of all mankind.
 
+      Much of this development follows EFNeXt but I try to keep the neat
+      stuff up to date for the EFNet release...
+ 
 2000/10/24  --- 1.11-REL done
 
 2000/10/24:
diff -uNrd -x CVS ircd-comstud-1.12-REL/configure.in ircd-devel/configure.in
--- ircd-comstud-1.12-REL/configure.in	Thu Jun  3 01:30:26 1999
+++ ircd-devel/configure.in	Tue Dec  5 12:29:00 2000
@@ -1,35 +1,44 @@
 dnl @(#)$Id configure.in,v 1.2 1995/01/07 01:50:18 mrg Exp$
-dnl
-dnl configure.in for ircd 2.9.
-dnl written by matthew green (mrg@mame.mu.oz.au), with portions
-dnl from avalon's Config.
-dnl copyright (c) 1995.
 
-AC_REVISION(1.2)dnl
 AC_INIT(source/ircdcore.c)
-AC_CONFIG_HEADER(include/setup.h:include/setup.h.in)
+dnl AC_CONFIG_AUX_DIR(config)
+AC_CONFIG_HEADER(include/setup.h)
+PACKAGE=ircd-comstud
+VERSION=1.11
+AC_SUBST(PACKAGE)
+AC_SUBST(VERSION)
 
+AC_CANONICAL_SYSTEM
 AC_PROG_CC
 AC_PROG_CPP
-AC_AIX
+AC_PROG_MAKE_SET
+
+dnl AC_ENABLE_SHARED
+dnl AC_DISABLE_STATIC
+dnl AC_LIBTOOL_DLOPEN
+dnl AM_PROG_LIBTOOL
+
 AC_ISC_POSIX
 AC_PROG_GCC_TRADITIONAL
+AC_C_CONST
+AC_C_INLINE
+AC_TYPE_SIGNAL
 
-AC_PATH_PROGS(SUM, sum cksum, true, /usr/ucb:$PATH)
-
-AC_CHECK_HEADERS(crypt.h stropts.h time.h sys/time.h sys/ioctl.h sys/filio.h)
+AC_CHECK_HEADERS(crypt.h stropts.h time.h sys/time.h sys/ioctl.h sys/filio.h sys/event.h)
 
 AC_CHECK_LIB(crypt, crypt)
+AC_CHECK_LIB(crypt, descrypt)
 AC_CHECK_LIB(socket, socket)
 AC_CHECK_LIB(nsl, socket)
 AC_CHECK_LIB(resolv, res_init)
-AC_CHECK_LIB(dl, dlopen)
 
-AC_CHECK_FUNC(getpagesize, AC_DEFINE(HAVE_GETPAGESIZE),
-	AC_CHECK_FUNC(sysconf, AC_DEFINE(HAVE_SYSCONF)))
+AC_CHECK_FUNC(select, AC_DEFINE(HAVE_SELECT))
 AC_CHECK_FUNC(poll, AC_DEFINE(HAVE_POLL))
+AC_CHECK_FUNC(kqueue, AC_DEFINE(HAVE_KQUEUE))
 AC_CHECK_FUNC(dn_skipname, , AC_DEFINE(NEED_DNSKIPNAME))
 AC_CHECK_FUNC(mmap, AC_DEFINE(HAVE_MMAP))
+AC_CHECK_FUNC(getpagesize, AC_DEFINE(HAVE_GETPAGESIZE),
+	AC_CHECK_FUNC(sysconf, AC_DEFINE(HAVE_SYSCONF)))
 AC_CHECK_FUNC(vsnprintf, AC_DEFINE(HAVE_VSNPRINTF))
 AC_CHECK_FUNC(strerror, AC_DEFINE(HAVE_STRERROR), 
 	AC_MSG_CHECKING(for sys_errlist declaration)
@@ -44,6 +53,10 @@
 }
 ],AC_DEFINE(SYS_ERRLIST_DECLARED) AC_MSG_RESULT(yes), AC_MSG_RESULT(no), :))
 
-AC_TYPE_SIGNAL()
+SHLIB_CC="${CC} -fPIC"
+SHLIB_LD="${CC} -shared"
 
-AC_OUTPUT(Makefile:Makefile.in)
+AC_SUBST(SHLIB_CC)
+AC_SUBST(SHLIB_LD)
+
+AC_OUTPUT(Makefile lib/Makefile source/Makefile utils/Makefile)
diff -uNrd -x CVS ircd-comstud-1.12-REL/include/access.h ircd-devel/include/access.h
--- ircd-comstud-1.12-REL/include/access.h	Wed Nov  8 00:51:38 2000
+++ ircd-devel/include/access.h	Sun Dec  3 12:17:45 2000
@@ -25,7 +25,6 @@
 	ircd_uint32_t		ip_net;
 	ircd_uint32_t		ip_mask;
 	char			*ipstring;
-#define ALLOW_FLAGS_CHECKHOSTNAME	0x001
 	int				flags;
 	char			*classname;
 	void			*classptr;
diff -uNrd -x CVS ircd-comstud-1.12-REL/include/confparse.h ircd-devel/include/confparse.h
--- ircd-comstud-1.12-REL/include/confparse.h	Wed Dec 31 19:00:00 1969
+++ ircd-devel/include/confparse.h	Tue Dec  5 12:23:23 2000
@@ -0,0 +1,63 @@
+/*
+**   Generic Config file parser (confparse.h)
+**   Copyright (C) 1999 Fred Jacobs, Chris Behrens
+**
+**   This program is free software; you can redistribute it and/or modify
+**   it under the terms of the GNU General Public License as published by
+**   the Free Software Foundation; either version 1, or (at your option)
+**   any later version.
+**
+**   This program is distributed in the hope that it will be useful,
+**   but WITHOUT ANY WARRANTY; without even the implied warranty of
+**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+**   GNU General Public License for more details.
+**
+**   You should have received a copy of the GNU General Public License
+**   along with this program; if not, write to the Free Software
+**   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+*/
+
+/*
+**  The idea of something this generic came solely from Fred Jacobs.
+**  I completely rewrote his implementation, however, although some
+**  pieces remain similar.  Thank you very much, Fred! :)
+**    - Chris
+*/
+
+#ifndef __CONFPARSE_H__
+#define __CONFPARSE_H__
+
+typedef struct _configfile	CONFIGFILE;
+typedef struct _configentry	CONFIGENTRY;
+
+struct _configfile
+{
+	char		*cf_filename;
+	CONFIGENTRY	*cf_entries;
+	CONFIGFILE	*cf_next;
+};
+
+struct _configentry
+{
+	CONFIGFILE	*ce_fileptr;
+
+	int			ce_varlinenum;
+	char		*ce_varname;
+	char		*ce_vardata;
+	int			ce_vardatanum;
+	int			ce_fileposstart;
+	int			ce_fileposend;
+
+	int			ce_sectlinenum;
+	CONFIGENTRY	*ce_entries;
+
+	CONFIGENTRY	*ce_prevlevel;
+
+	CONFIGENTRY	*ce_next;
+};
+
+void config_free(CONFIGFILE *cfptr);
+CONFIGFILE *config_load(char *filename);
+CONFIGENTRY *config_find(CONFIGENTRY *ceptr, char *name);
+
+#endif
diff -uNrd -x CVS ircd-comstud-1.12-REL/include/defines.h ircd-devel/include/defines.h
--- ircd-comstud-1.12-REL/include/defines.h	Tue Nov  9 23:41:06 1999
+++ ircd-devel/include/defines.h	Sun Dec  3 12:17:45 2000
@@ -59,7 +59,6 @@
 #define IsMember			_channel_ismember
 
 extern char				*Conffile;
-extern FDLIST			*Fdlist_main;
 extern IRCD_CONN		**Fds;
 extern int				Fds_size;
 extern IRCDRES_REQLIST	*Reqlist;
diff -uNrd -x CVS ircd-comstud-1.12-REL/include/fdlist.h ircd-devel/include/fdlist.h
--- ircd-comstud-1.12-REL/include/fdlist.h	Sun Jul 18 14:39:17 1999
+++ ircd-devel/include/fdlist.h	Tue Dec  5 05:58:40 2000
@@ -1,48 +1,19 @@
 #ifndef __FDLIST_H__
 #define __FDLIST_H__
 
+#include "structs.h"
 #include "config.h"
 
 #include <string.h>
-/*
-#include <poll.h>
-*/
+#include <sys/event.h>
 
 typedef struct pollfd		FDLIST_POLLFD;
 
 #define FDLIST_FLAGS_READ	0x001
 #define FDLIST_FLAGS_WRITE	0x002
 
-typedef struct _fdlist		FDLIST;
-typedef struct _fdlistinfo	FDLISTINFO;
-
-struct _fdlist
-{
-	FDLIST_POLLFD	*pfd_array;
-	int				pfd_size;
-	int				pfd_num;
-};
-
-struct _fdlistinfo
-{
-    int             fd;
-    FDLIST          *fdlist;
-    int             fdlist_pos;
-};
-
-#define FDLIST_FD(__fdlist, __pos)	(__fdlist)->pfd_array[(__pos)].fd
-
-#define SET_FDS(__fd, __ptr)	Fds[(__fd)] = (__ptr)
-#define GET_FDS(__fd)			Fds[(__fd)]
-
-#define fdlist_events(__fdlist, __pos)	(__fdlist)->pfd_array[(__pos)].events
-#define fdlist_init(__fdlist)	memset((__fdlist), 0, sizeof(FDLIST))
-
-int fdlist_add_fd(FDLIST *fdlist, int fd, int flags);
-int fdlist_del_fd(FDLIST *fdlist, int pos, int *mfd);
-int fdlist_add_event(FDLIST *fdlist, int pos, int flags);
-int fdlist_del_event(FDLIST *fdlist, int pos, int flags);
-int fdlist_set_events(FDLIST *fdlist, int pos, int flags);
-int fdlist_get_events(FDLIST *fdlist, int pos);
+struct kevent *fdlist_kqueue_increase(struct kevent *, int);
+int fdlist_add_event(IRCD_CONN *, int);
+int fdlist_del_event(IRCD_CONN *, int);
 
 #endif
diff -uNrd -x CVS ircd-comstud-1.12-REL/include/misc.h ircd-devel/include/misc.h
--- ircd-comstud-1.12-REL/include/misc.h	Sun Oct 22 21:38:45 2000
+++ ircd-devel/include/misc.h	Sun Dec  3 12:17:45 2000
@@ -6,8 +6,8 @@
 #define NEXTARG_FLAGS_LASTARG	0x001
 
 void command_tree_init(void);
-int ircd_open_fd(int fd, int flags, IRCD_CONN *cptr, FDLIST *fdlistptr);
-int ircd_close_fd(FDLISTINFO *fdlistinfo);
+int ircd_open_fd(int fd, int flags, IRCD_CONN *cptr);
+int ircd_close_fd(int fd);
 int client_add_rejecthold(int fd, struct sockaddr_in *rem_sin);
 int client_add_local(IRCD_LISTENER *listener, int fd, struct sockaddr_in *rem_sin);
 int rejecthold_del(IRCD_CLIENT *from, IRCD_REJECTHOLD *rptr, char *reason);
diff -uNrd -x CVS ircd-comstud-1.12-REL/include/structs.h ircd-devel/include/structs.h
--- ircd-comstud-1.12-REL/include/structs.h	Wed Nov  8 00:49:22 2000
+++ ircd-devel/include/structs.h	Tue Dec  5 10:54:28 2000
@@ -2,12 +2,9 @@
 #define __STRUCTS_H__
 
 #include "defines.h"
-#include "fdlist.h"
 #include "queue.h"
 #include "res.h"
 
-#define ALLOW_FLAGS_CHECKHOSTNAME	0x001
-
 typedef struct _ircd_conn			IRCD_CONN;
 typedef struct _ircd_auth			IRCD_AUTH;
 typedef struct _ircd_rejecthold		IRCD_REJECTHOLD;
@@ -29,7 +26,7 @@
 
 struct _ircd_conn
 {
-	FDLISTINFO		fdlistinfo;
+	int				fd;
 #define IRCD_CONN_TYPE_CLIENT		0x001
 #define IRCD_CONN_TYPE_AUTH			0x002
 #define IRCD_CONN_TYPE_LISTENER		0x004
@@ -254,7 +251,7 @@
 	IRCD_CLIENT		*c_h_prev;
 	IRCD_CLIENT		*c_h_next;
 
-	IRCD_IPENTRY	*c_ipaddr_ptr;
+	IRCD_IPENTRY		*c_ipaddr_ptr;
 	IRCD_CLIENT		*c_i_prev;
 	IRCD_CLIENT		*c_i_next;
 	IRCD_CLIENT		*c_n_prev;
@@ -409,8 +406,6 @@
 	int				c_recv_msg;
 	int				c_recv_bytes;
 	int				c_recv_kbytes;
-
-	int				c_writetries;
 
 	int				c_rate_msgs;
 	int				c_rate_time;
diff -uNrd -x CVS ircd-comstud-1.12-REL/include/version.h ircd-devel/include/version.h
--- ircd-comstud-1.12-REL/include/version.h	Wed Nov  8 00:38:14 2000
+++ ircd-devel/include/version.h	Sun Dec  3 12:17:45 2000
@@ -1,7 +1,7 @@
 #ifndef __VERSION_H__
 #define __VERSION_H__
 
-#define VERSIONSTRING "2.8/comstud-1.12-REL"
+#define VERSIONSTRING "2.8/comstud-1.11-REL"
 
 #ifdef CONCENTRIC
 #define VERSION VERSIONSTRING "+cnc"
diff -uNrd -x CVS ircd-comstud-1.12-REL/install-sh ircd-devel/install-sh
--- ircd-comstud-1.12-REL/install-sh	Wed Dec 31 19:00:00 1969
+++ ircd-devel/install-sh	Tue Dec  5 12:24:50 2000
@@ -0,0 +1,251 @@
+#!/bin/sh
+#
+# install - install a program, script, or datafile
+# This comes from X11R5 (mit/util/scripts/install.sh).
+#
+# Copyright 1991 by the Massachusetts Institute of Technology
+#
+# Permission to use, copy, modify, distribute, and sell this software and its
+# documentation for any purpose is hereby granted without fee, provided that
+# the above copyright notice appear in all copies and that both that
+# copyright notice and this permission notice appear in supporting
+# documentation, and that the name of M.I.T. not be used in advertising or
+# publicity pertaining to distribution of the software without specific,
+# written prior permission.  M.I.T. makes no representations about the
+# suitability of this software for any purpose.  It is provided "as is"
+# without express or implied warranty.
+#
+# Calling this script install-sh is preferred over install.sh, to prevent
+# `make' implicit rules from creating a file called install from it
+# when there is no Makefile.
+#
+# This script is compatible with the BSD install script, but was written
+# from scratch.  It can only install one file at a time, a restriction
+# shared with many OS's install programs.
+
+
+# set DOITPROG to echo to test this script
+
+# Don't use :- since 4.3BSD and earlier shells don't like it.
+doit="${DOITPROG-}"
+
+
+# put in absolute paths if you don't have them in your path; or use env. vars.
+
+mvprog="${MVPROG-mv}"
+cpprog="${CPPROG-cp}"
+chmodprog="${CHMODPROG-chmod}"
+chownprog="${CHOWNPROG-chown}"
+chgrpprog="${CHGRPPROG-chgrp}"
+stripprog="${STRIPPROG-strip}"
+rmprog="${RMPROG-rm}"
+mkdirprog="${MKDIRPROG-mkdir}"
+
+transformbasename=""
+transform_arg=""
+instcmd="$mvprog"
+chmodcmd="$chmodprog 0755"
+chowncmd=""
+chgrpcmd=""
+stripcmd=""
+rmcmd="$rmprog -f"
+mvcmd="$mvprog"
+src=""
+dst=""
+dir_arg=""
+
+while [ x"$1" != x ]; do
+    case $1 in
+	-c) instcmd="$cpprog"
+	    shift
+	    continue;;
+
+	-d) dir_arg=true
+	    shift
+	    continue;;
+
+	-m) chmodcmd="$chmodprog $2"
+	    shift
+	    shift
+	    continue;;
+
+	-o) chowncmd="$chownprog $2"
+	    shift
+	    shift
+	    continue;;
+
+	-g) chgrpcmd="$chgrpprog $2"
+	    shift
+	    shift
+	    continue;;
+
+	-s) stripcmd="$stripprog"
+	    shift
+	    continue;;
+
+	-t=*) transformarg=`echo $1 | sed 's/-t=//'`
+	    shift
+	    continue;;
+
+	-b=*) transformbasename=`echo $1 | sed 's/-b=//'`
+	    shift
+	    continue;;
+
+	*)  if [ x"$src" = x ]
+	    then
+		src=$1
+	    else
+		# this colon is to work around a 386BSD /bin/sh bug
+		:
+		dst=$1
+	    fi
+	    shift
+	    continue;;
+    esac
+done
+
+if [ x"$src" = x ]
+then
+	echo "install:	no input file specified"
+	exit 1
+else
+	true
+fi
+
+if [ x"$dir_arg" != x ]; then
+	dst=$src
+	src=""
+	
+	if [ -d $dst ]; then
+		instcmd=:
+		chmodcmd=""
+	else
+		instcmd=mkdir
+	fi
+else
+
+# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
+# might cause directories to be created, which would be especially bad 
+# if $src (and thus $dsttmp) contains '*'.
+
+	if [ -f $src -o -d $src ]
+	then
+		true
+	else
+		echo "install:  $src does not exist"
+		exit 1
+	fi
+	
+	if [ x"$dst" = x ]
+	then
+		echo "install:	no destination specified"
+		exit 1
+	else
+		true
+	fi
+
+# If destination is a directory, append the input filename; if your system
+# does not like double slashes in filenames, you may need to add some logic
+
+	if [ -d $dst ]
+	then
+		dst="$dst"/`basename $src`
+	else
+		true
+	fi
+fi
+
+## this sed command emulates the dirname command
+dstdir=`echo $dst | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
+
+# Make sure that the destination directory exists.
+#  this part is taken from Noah Friedman's mkinstalldirs script
+
+# Skip lots of stat calls in the usual case.
+if [ ! -d "$dstdir" ]; then
+defaultIFS='	
+'
+IFS="${IFS-${defaultIFS}}"
+
+oIFS="${IFS}"
+# Some sh's can't handle IFS=/ for some reason.
+IFS='%'
+set - `echo ${dstdir} | sed -e 's@/@%@g' -e 's@^%@/@'`
+IFS="${oIFS}"
+
+pathcomp=''
+
+while [ $# -ne 0 ] ; do
+	pathcomp="${pathcomp}${1}"
+	shift
+
+	if [ ! -d "${pathcomp}" ] ;
+        then
+		$mkdirprog "${pathcomp}"
+	else
+		true
+	fi
+
+	pathcomp="${pathcomp}/"
+done
+fi
+
+if [ x"$dir_arg" != x ]
+then
+	$doit $instcmd $dst &&
+
+	if [ x"$chowncmd" != x ]; then $doit $chowncmd $dst; else true ; fi &&
+	if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dst; else true ; fi &&
+	if [ x"$stripcmd" != x ]; then $doit $stripcmd $dst; else true ; fi &&
+	if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dst; else true ; fi
+else
+
+# If we're going to rename the final executable, determine the name now.
+
+	if [ x"$transformarg" = x ] 
+	then
+		dstfile=`basename $dst`
+	else
+		dstfile=`basename $dst $transformbasename | 
+			sed $transformarg`$transformbasename
+	fi
+
+# don't allow the sed command to completely eliminate the filename
+
+	if [ x"$dstfile" = x ] 
+	then
+		dstfile=`basename $dst`
+	else
+		true
+	fi
+
+# Make a temp file name in the proper directory.
+
+	dsttmp=$dstdir/#inst.$$#
+
+# Move or copy the file name to the temp name
+
+	$doit $instcmd $src $dsttmp &&
+
+	trap "rm -f ${dsttmp}" 0 &&
+
+# and set any options; do chmod last to preserve setuid bits
+
+# If any of these fail, we abort the whole thing.  If we want to
+# ignore errors from any of these, just make sure not to ignore
+# errors from the above "$doit $instcmd $src $dsttmp" command.
+
+	if [ x"$chowncmd" != x ]; then $doit $chowncmd $dsttmp; else true;fi &&
+	if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dsttmp; else true;fi &&
+	if [ x"$stripcmd" != x ]; then $doit $stripcmd $dsttmp; else true;fi &&
+	if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dsttmp; else true;fi &&
+
+# Now rename the file to the real destination.
+
+	$doit $rmcmd -f $dstdir/$dstfile &&
+	$doit $mvcmd $dsttmp $dstdir/$dstfile 
+
+fi &&
+
+
+exit 0
diff -uNrd -x CVS ircd-comstud-1.12-REL/ircd.conf ircd-devel/ircd.conf
--- ircd-comstud-1.12-REL/ircd.conf	Wed Dec 31 19:00:00 1969
+++ ircd-devel/ircd.conf	Sun Dec 10 07:46:32 2000
@@ -0,0 +1,79 @@
+global {
+	name irc.freebsd.org;
+	info "Development and testing server";
+	nameserver 127.0.0.1;
+};
+
+listen {
+	address 127.0.0.1 {
+		port 31337;
+	};
+};
+
+
+set {
+	clientconnect yes;
+        chanopsonsplit 6;
+        maxclients 32000;
+        goodoper_log yes;
+        badoper_log yes;
+        clones_log yes;
+        users_log no;
+        newklines_file "kline.conf";
+        isoperstring "is routing packets to Null0 (IRC Operator)";
+        reject_hold 15;
+	IPADDR_ACCEPT_RATE_NUM 0;
+	ipaddr_client_rate_num 0;
+	show_nickchanges no;
+        default_maxchannels 20;
+        operscanjoinonsplit yes;
+};
+
+admin {
+        "irc.freebsd.org administration";
+        "pm        ( Dave McKay    )";
+        "bfumerola ( Bill Fumerola )";
+        "ik        ( Dan Haskell   )";
+};
+
+class users {
+	maxsendq 640000;
+	maxclients 4096;
+	pingfreq 99999;
+	recvbuf 16384;
+	sendbuf 16384;
+};
+
+allow { hostname *; username *; class users; };
+allow { ipaddr *; username *; class users; };
+
+opers {
+	name testing {
+		from {
+			username *;
+			hostname *;
+		};
+		passwd "$1$TDK9j7iW$CrZTapr9Xdc79h9o22mqH0";
+		flag {
+			canset;		/* Can "/quote set" */
+			candie;		/* Can "/quote die" the server */
+			canflood;	/* Can Flood (without lag) */
+			cankline;	/* Can "/quote kline" */
+			canunkline;	/* Can "/quote unkline" */
+			canrehash;	/* Can "/quote rehash" the server */
+			canlocalkill;	/* Can /kill Locally */
+			canlocalroute;	/* Can /connect & /squit locally */
+		};
+                userflag {
+                        SWALLOPS;
+                        OKILLS;
+                        SNOTICES;
+                        OWALLOPS;
+                        STATSNOTICES;
+                        THROTTLES;
+                        LWALLOPS;
+                        CONNECTS;
+                        SQUITS;
+                };
+	};
+};
diff -uNrd -x CVS ircd-comstud-1.12-REL/ircd.motd ircd-devel/ircd.motd
--- ircd-comstud-1.12-REL/ircd.motd	Wed Dec 31 19:00:00 1969
+++ ircd-devel/ircd.motd	Tue Dec  5 12:46:33 2000
@@ -0,0 +1,36 @@
+   $Id$
+
+   \. admins \._________________________________________________
+
+      (pm)        - (dave@sneakerz.org)
+      (bfumerola) - (billf@FreeBSD.org)
+      (ik)        - (ik@lsl.com)
+
+      Questions / Complaints    - (irc@freebsd.org)
+
+   \. client policy \.__________________________________________
+
+      > clones (more than 2 u@h) will be klined without notice.
+      > if you have plans to flood / spam or otherwise act
+        in an inappropriate manner, save the operator staff
+        some time and /quit.
+      > your client must be set to respond to CTCP queries.
+      > violation of any of these terms will result in a kline.
+        if you feel your kline was unjustified, email irc@freebsd.org
+        with the user@host you were using at the time, as well
+        a description of what happened.
+
+   \. bot policy \._____________________________________________
+
+      > we will allow a single connection from a non-abusive bot.
+
+   \. involvement policy \._____________________________________
+
+      > this server is maintained by a group of dedicated
+        admins and operators. a list of active opers can be
+        obtained using /stats p. overall keep in mind your
+        use of this server is a privilege, NOT A RIGHT.
+        to be more specific, your connection can be terminated
+        any time at the sole discretion of the operator staff.
+
+	Remember:      ITS JUST IRC
diff -uNrd -x CVS ircd-comstud-1.12-REL/ircd.pid ircd-devel/ircd.pid
--- ircd-comstud-1.12-REL/ircd.pid	Wed Dec 31 19:00:00 1969
+++ ircd-devel/ircd.pid	Sun Dec 10 08:51:16 2000
@@ -0,0 +1 @@
+53620
diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/commands.c ircd-devel/lib/commands.c
--- ircd-comstud-1.12-REL/lib/commands.c	Thu Nov 23 23:23:55 2000
+++ ircd-devel/lib/commands.c	Tue Dec  5 12:37:20 2000
@@ -22,7 +22,7 @@
 
 #include "ircd_includes.h"
 #include "commands.h"
-#include "../confparse/configparse.h"
+#include "confparse.h"
 
 RCSID("$Id: commands.c,v 1.40 1999/02/23 07:57:15 cbehrens Exp $");
 
@@ -173,8 +173,7 @@
 
 	for(;*tptr;tptr++)
 	{
-		if ((*tptr <= ' ') || (*tptr > 'z') || (*tptr == ':') ||
-				(*tptr == '*') || (*tptr == '%'))
+		if ((*tptr <= ' ') || (*tptr > 'z') || (*tptr == ':') || (*tptr == '*'))
 			break;
 		if (*tptr == '.')
 			dotptr = tptr;
@@ -302,6 +301,9 @@
 				case	-7: /* host limit exceeded */
 					strcpy(exitbuf, "Class uservhost limit exceeded");
 					break;
+				case	-8: /* incorrect password */
+					strcpy(exitbuf, "Incorrect password");
+					break;
 				default:
 					sprintf(exitbuf, "Unknown error: %i", err);
 					break;
@@ -2947,11 +2949,6 @@
 	send_to_flag(CLIENT_NFLAGS_CONNECTS, NULL,
 			"Server %s being introduced locally", lptr->name);
 
-	ret = Recvbuffersize;
-	setsockopt(lptr->c_connptr->fdlistinfo.fd, SOL_SOCKET, SO_RCVBUF, (char *)&ret, sizeof(ret));
-	ret = Sendbuffersize;
-	setsockopt(lptr->c_connptr->fdlistinfo.fd, SOL_SOCKET, SO_SNDBUF, (char *)&ret, sizeof(ret));
-
 	if (++Globalinfo->g_servers > Globalinfo->g_maxservers)
 	{
 		Globalinfo->g_maxservers = Globalinfo->g_servers;
@@ -4497,7 +4494,7 @@
 		return -1;
 	}
 
-	if (ircd_open_fd(afd, FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE, acptr->c_connptr, NULL) < 0)
+	if (ircd_open_fd(afd, FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE, acptr->c_connptr) < 0)
 	{
 		queue_delete(&(acptr->c_queue_out));
 		queue_delete(&(acptr->c_queue_in));
@@ -5235,12 +5232,12 @@
 					send_prefix_to_client(meptr, pptr,
 						IRCD_REPLY(RPL_TRACEOPERATOR, pptr->name),
 						acptr->c_class->classname,
-						ircd_clientname(acptr, 0, cnamebuf));
+						ircd_clientname(acptr, 0, cnamebuf), acptr->c_ipstring);
 				else
 					send_prefix_to_client(meptr, pptr,
 						IRCD_REPLY(RPL_TRACEUSER, pptr->name),
 						acptr->c_class->classname,
-						ircd_clientname(acptr, 0, cnamebuf));
+						ircd_clientname(acptr, 0, cnamebuf), acptr->c_ipstring);
 			}
 			else if (IsServer(acptr))
 			{
@@ -5273,21 +5270,21 @@
 					send_prefix_to_client(meptr, pptr,
 						IRCD_REPLY(RPL_TRACEOPERATOR, pptr->name),
 						acptr->c_class->classname,
-						ircd_clientname(acptr, 0, cnamebuf));
+						ircd_clientname(acptr, 0, cnamebuf), acptr->c_ipstring);
 				}
 				else if (IsAnOper(pptr))
 				{
 					send_prefix_to_client(meptr, pptr,
 						IRCD_REPLY(RPL_TRACEUSER, pptr->name),
 						acptr->c_class->classname,
-						ircd_clientname(acptr, 0, cnamebuf));
+						ircd_clientname(acptr, 0, cnamebuf), acptr->c_ipstring);
 				}
 			}
 			else if (IsUnknown(acptr) && IsAnOper(pptr))
 			{
 				send_prefix_to_client(meptr, pptr,
 					IRCD_REPLY(RPL_TRACEUNKNOWN, pptr->name),
-					acptr->c_class ? acptr->c_class->classname : "unknown", ircd_clientname(acptr, 0, cnamebuf));
+					acptr->c_class ? acptr->c_class->classname : "unknown", ircd_clientname(acptr, 0, cnamebuf), acptr->c_ipstring);
 			}
 		}
 		if (IsAnOper(pptr))
diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/conf.c ircd-devel/lib/conf.c
--- ircd-comstud-1.12-REL/lib/conf.c	Wed Nov  8 00:54:49 2000
+++ ircd-devel/lib/conf.c	Tue Dec  5 12:37:09 2000
@@ -22,9 +22,8 @@
 
 #include "ircd_includes.h"
 #include "conf.h"
-#include "../confparse/configparse.h"
+#include "confparse.h"
 #include "commands.h"
-#include "access.h"
 
 RCSID("$Id: conf.c,v 1.17 1999/02/21 22:34:39 cbehrens Exp $");
 
@@ -238,10 +237,7 @@
 						ce->ce_fileptr->cf_filename, ce->ce_varlinenum);
 					continue;
 				}
-				if (!strcasecmp(flagname, "checkhostname"))
-					flags |= ALLOW_FLAGS_CHECKHOSTNAME;
-				else
-					syslog(LOG_NOTICE,
+				syslog(LOG_NOTICE,
 						"%s:%i: unknown flag",
 						ce->ce_fileptr->cf_filename, ce2->ce_varlinenum);
 			}
@@ -309,7 +305,7 @@
 
 static int _conf_class(IRCDCONF *conf, CONFIGENTRY *ce)
 {
-	IRCD_CLASSENTRY		class;
+	IRCD_CLASSENTRY		class, *ceptr;
 	int					ret;
 	CONFIGENTRY			*ce2;
 
@@ -356,7 +352,44 @@
 	
 	for(ce=ce->ce_entries;ce;ce=ce->ce_next)
 	{
-		if (!strcasecmp(ce->ce_varname, "maxsendq"))
+
+		if (!strcasecmp(ce->ce_varname, "inherit"))
+		{
+		        if (!ce->ce_vardata || !*ce->ce_vardata)
+		        {
+		                syslog(LOG_NOTICE,
+		                                "%s:%i: no inherit specified",
+		                                ce->ce_fileptr->cf_filename, ce->ce_varlinenum);
+		                continue;
+		        }
+                        
+		        ret = class_find(&(_ircd_conf.classes), ce->ce_vardata, &ceptr);
+                        
+		        if (ret < 0)
+		        {
+		                syslog(LOG_NOTICE,
+		                                "%s:%i: could not find classname",
+		                                ce->ce_fileptr->cf_filename, ce->ce_varlinenum);
+		                continue;
+		        }
+
+                        class.maxsendq = ceptr->maxsendq;
+                        class.pingfreq = ceptr->pingfreq;
+                        class.connfreq = ceptr->connfreq;
+                        class.maxclients = ceptr->maxclients;
+                        class.flags = ceptr->flags;
+                        class.floodnum = ceptr->floodnum;
+                        class.floodtime = ceptr->floodtime;
+                        class.floodexit = ceptr->floodexit;
+                        class.uhlimit = ceptr->uhlimit;
+                        class.hlimit = ceptr->hlimit;
+                        class.uvlimit = ceptr->uvlimit;
+                        class.vlimit = ceptr->vlimit;
+                        class.ipaddr_rate_time = ceptr->ipaddr_rate_time;
+                        class.ipaddr_rate_num = ceptr->ipaddr_rate_num;
+                        class.maxchannels = ceptr->maxchannels;
+		}
+		else if (!strcasecmp(ce->ce_varname, "maxsendq"))
 		{
 			if (!ce->ce_vardata)
 			{
@@ -1807,7 +1840,7 @@
 		if (!l->l_num_on)
 		{
 			del_listener_from_llist(lptr, l);
-			ircd_close_fd(&(l->l_connptr->fdlistinfo));
+			ircd_close_fd(l->l_connptr->fd);
 			MyFree(l->l_connptr);
 			MyFree(l);
 		}
@@ -1848,7 +1881,7 @@
 	l->l_connptr->conn_type = IRCD_CONN_TYPE_LISTENER;
 	l->l_connptr->conn_ptr = (void *)l;
 
-	if ((ret = ircd_open_fd(fd, FDLIST_FLAGS_READ, l->l_connptr, NULL)) < 0)
+	if ((ret = ircd_open_fd(fd, FDLIST_FLAGS_READ, l->l_connptr)) < 0)
 	{
 		close(fd);
 		MyFree(l->l_connptr);
@@ -2196,21 +2229,10 @@
 				pptr->username, pptr->c_ipstring,
 				pptr->c_rem_ipaddr, ACCESS_FLAGS_BESTMATCH,
 				&entryptr);
-	if (strcmp(pptr->c_ipstring, pptr->hostname) &&
-		((ret < 0) || (entryptr->flags & ALLOW_FLAGS_CHECKHOSTNAME)))
-	{
-		CONFHOSTIPENTRY		*eptr;
-		int				r;
-
-		r = access_match_hostname(&(_ircd_conf.allow),
+	if ((ret < 0) && strcmp(pptr->c_ipstring, pptr->hostname))
+		ret = access_match_hostname(&(_ircd_conf.allow),
 				pptr->username, pptr->hostname, ACCESS_FLAGS_BESTMATCH,
-				&eptr);
-		if (!r)
-		{
-			entryptr = eptr;
-			ret = r;
-		}
-	}
+				&entryptr);
 
 	/* FIX...check pptr->res_req->rl_reverse aliases also */
 
@@ -2224,6 +2246,11 @@
 		if (err)
 			*err = ret;
 		return -1;
+	}
+
+	if (entryptr->data && pptr->c_passwd && strcmp(entryptr->data, pptr->c_passwd))
+	{
+		return -8;
 	}
 
 	if (entryptr->classptr)
